"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
TODO_AUTOMATE: Add a CI workflow which detects .proto files with incompatible names (i.e. same as the package).
NB: This file CANNOT be named "application.proto" due to an as of yet unidentified
issue in how cosmos-proto generates the pulsar plugin output go source code.
"""

import builtins
import collections.abc
import cosmos.base.v1beta1.coin_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import poktroll.shared.service_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class Application(google.protobuf.message.Message):
    """Application defines the type used to store an on-chain definition and state for an application"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class PendingUndelegationsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.int
        @property
        def value(self) -> global___UndelegatingGatewayList: ...
        def __init__(
            self,
            *,
            key: builtins.int = ...,
            value: global___UndelegatingGatewayList | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    ADDRESS_FIELD_NUMBER: builtins.int
    STAKE_FIELD_NUMBER: builtins.int
    SERVICE_CONFIGS_FIELD_NUMBER: builtins.int
    DELEGATEE_GATEWAY_ADDRESSES_FIELD_NUMBER: builtins.int
    PENDING_UNDELEGATIONS_FIELD_NUMBER: builtins.int
    UNSTAKE_SESSION_END_HEIGHT_FIELD_NUMBER: builtins.int
    PENDING_TRANSFER_FIELD_NUMBER: builtins.int
    address: builtins.str
    """The Bech32 address of the application."""
    unstake_session_end_height: builtins.int
    """The end height of the session at which an application initiated its unstaking process.
    If the application did not unstake, this value will be 0.
    """
    @property
    def stake(self) -> cosmos.base.v1beta1.coin_pb2.Coin:
        """The total amount of uPOKT the application has staked"""

    @property
    def service_configs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[poktroll.shared.service_pb2.ApplicationServiceConfig]:
        """CRITICAL_DEV_NOTE: The number of service_configs must be EXACTLY ONE.
        This prevents applications from over-servicing.
        The field is kept repeated (a list) for both legacy and future logic reaosns.
        References:
         - https://github.com/pokt-network/poktroll/pull/750#discussion_r1735025033
         - https://www.notion.so/buildwithgrove/Off-chain-Application-Stake-Tracking-6a8bebb107db4f7f9dc62cbe7ba555f7
        The list of services this appliccation is configured to request service for
        """

    @property
    def delegatee_gateway_addresses(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """TODO_BETA(@bryanchriswhite): Rename `delegatee_gateway_addresses` to `gateway_addresses_delegated_to`.
        Ensure to rename all relevant configs, comments, variables, function names, etc as well.
        The Bech32 encoded addresses for all delegatee Gateways, in a non-nullable slice
        """

    @property
    def pending_undelegations(self) -> google.protobuf.internal.containers.MessageMap[builtins.int, global___UndelegatingGatewayList]:
        """A map from sessionEndHeights to a list of Gateways.
        The key is the height of the last block of the session during which the
        respective undelegation was committed.
        The value is a list of gateways being undelegated from.
        TODO_DOCUMENT(@red-0ne): Need to document the flow from this comment
        so its clear to everyone why this is necessary; https://github.com/pokt-network/poktroll/issues/476#issuecomment-2052639906.
        """

    @property
    def pending_transfer(self) -> global___PendingApplicationTransfer: ...
    def __init__(
        self,
        *,
        address: builtins.str = ...,
        stake: cosmos.base.v1beta1.coin_pb2.Coin | None = ...,
        service_configs: collections.abc.Iterable[poktroll.shared.service_pb2.ApplicationServiceConfig] | None = ...,
        delegatee_gateway_addresses: collections.abc.Iterable[builtins.str] | None = ...,
        pending_undelegations: collections.abc.Mapping[builtins.int, global___UndelegatingGatewayList] | None = ...,
        unstake_session_end_height: builtins.int = ...,
        pending_transfer: global___PendingApplicationTransfer | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["pending_transfer", b"pending_transfer", "stake", b"stake"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["address", b"address", "delegatee_gateway_addresses", b"delegatee_gateway_addresses", "pending_transfer", b"pending_transfer", "pending_undelegations", b"pending_undelegations", "service_configs", b"service_configs", "stake", b"stake", "unstake_session_end_height", b"unstake_session_end_height"]) -> None: ...

global___Application = Application

@typing.final
class UndelegatingGatewayList(google.protobuf.message.Message):
    """UndelegatingGatewayList is used as the Value of `pending_undelegations`.
    It is required to store a repeated list of strings as a map value.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    GATEWAY_ADDRESSES_FIELD_NUMBER: builtins.int
    @property
    def gateway_addresses(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]: ...
    def __init__(
        self,
        *,
        gateway_addresses: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["gateway_addresses", b"gateway_addresses"]) -> None: ...

global___UndelegatingGatewayList = UndelegatingGatewayList

@typing.final
class PendingApplicationTransfer(google.protobuf.message.Message):
    """PendingTransfer is used to store the details of a pending transfer.
    It is only intended to be used inside of an Application object.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DESTINATION_ADDRESS_FIELD_NUMBER: builtins.int
    SESSION_END_HEIGHT_FIELD_NUMBER: builtins.int
    destination_address: builtins.str
    session_end_height: builtins.int
    def __init__(
        self,
        *,
        destination_address: builtins.str = ...,
        session_end_height: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["destination_address", b"destination_address", "session_end_height", b"session_end_height"]) -> None: ...

global___PendingApplicationTransfer = PendingApplicationTransfer
