"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import cosmos.base.v1beta1.coin_pb2
import google.protobuf.descriptor
import google.protobuf.message
import poktroll.gateway.params_pb2
import poktroll.gateway.types_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class MsgUpdateParams(google.protobuf.message.Message):
    """MsgUpdateParams is the Msg/UpdateParams request type."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUTHORITY_FIELD_NUMBER: builtins.int
    PARAMS_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority is the address that controls the module (defaults to x/gov unless overwritten)."""
    @property
    def params(self) -> poktroll.gateway.params_pb2.Params:
        """TODO_IMPROVE(#322): The requirement to provide all params is adopted from the
        latest Cosmos SDK version. We should look into either improving this ourselves
        or seeing if it is on their roadmap.

        params defines the x/gateway parameters to update.
        NOTE: All parameters must be supplied.
        """

    def __init__(
        self,
        *,
        authority: builtins.str = ...,
        params: poktroll.gateway.params_pb2.Params | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["authority", b"authority", "params", b"params"]) -> None: ...

global___MsgUpdateParams = MsgUpdateParams

@typing.final
class MsgUpdateParamsResponse(google.protobuf.message.Message):
    """MsgUpdateParamsResponse defines the response structure for executing a
    MsgUpdateParams message.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgUpdateParamsResponse = MsgUpdateParamsResponse

@typing.final
class MsgStakeGateway(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ADDRESS_FIELD_NUMBER: builtins.int
    STAKE_FIELD_NUMBER: builtins.int
    address: builtins.str
    """The Bech32 address of the gateway"""
    @property
    def stake(self) -> cosmos.base.v1beta1.coin_pb2.Coin:
        """The total amount of uPOKT the gateway is staking. Must be ≥ to the current amount that the gateway has staked (if any)"""

    def __init__(
        self,
        *,
        address: builtins.str = ...,
        stake: cosmos.base.v1beta1.coin_pb2.Coin | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["stake", b"stake"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["address", b"address", "stake", b"stake"]) -> None: ...

global___MsgStakeGateway = MsgStakeGateway

@typing.final
class MsgStakeGatewayResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    GATEWAY_FIELD_NUMBER: builtins.int
    @property
    def gateway(self) -> poktroll.gateway.types_pb2.Gateway: ...
    def __init__(
        self,
        *,
        gateway: poktroll.gateway.types_pb2.Gateway | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["gateway", b"gateway"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["gateway", b"gateway"]) -> None: ...

global___MsgStakeGatewayResponse = MsgStakeGatewayResponse

@typing.final
class MsgUnstakeGateway(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ADDRESS_FIELD_NUMBER: builtins.int
    address: builtins.str
    """The Bech32 address of the gateway"""
    def __init__(
        self,
        *,
        address: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["address", b"address"]) -> None: ...

global___MsgUnstakeGateway = MsgUnstakeGateway

@typing.final
class MsgUnstakeGatewayResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgUnstakeGatewayResponse = MsgUnstakeGatewayResponse

@typing.final
class MsgUpdateParam(google.protobuf.message.Message):
    """MsgUpdateParam is the Msg/UpdateParam request type to update a single param."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUTHORITY_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    AS_COIN_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority is the address that controls the module (defaults to x/gov unless overwritten)."""
    name: builtins.str
    @property
    def as_coin(self) -> cosmos.base.v1beta1.coin_pb2.Coin: ...
    def __init__(
        self,
        *,
        authority: builtins.str = ...,
        name: builtins.str = ...,
        as_coin: cosmos.base.v1beta1.coin_pb2.Coin | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["as_coin", b"as_coin", "as_type", b"as_type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["as_coin", b"as_coin", "as_type", b"as_type", "authority", b"authority", "name", b"name"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["as_type", b"as_type"]) -> typing.Literal["as_coin"] | None: ...

global___MsgUpdateParam = MsgUpdateParam

@typing.final
class MsgUpdateParamResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARAMS_FIELD_NUMBER: builtins.int
    @property
    def params(self) -> poktroll.gateway.params_pb2.Params: ...
    def __init__(
        self,
        *,
        params: poktroll.gateway.params_pb2.Params | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["params", b"params"]) -> None: ...

global___MsgUpdateParamResponse = MsgUpdateParamResponse
