"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class RelayMiningDifficulty(google.protobuf.message.Message):
    """RelayMiningDifficulty is a message used to store the on-chain Relay Mining
    difficulty associated with a specific service ID.
    TODO_TECHDEBT: Embed this message in the Service message.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SERVICE_ID_FIELD_NUMBER: builtins.int
    BLOCK_HEIGHT_FIELD_NUMBER: builtins.int
    NUM_RELAYS_EMA_FIELD_NUMBER: builtins.int
    TARGET_HASH_FIELD_NUMBER: builtins.int
    service_id: builtins.str
    """The service ID the relay mining difficulty is associated with."""
    block_height: builtins.int
    """The block height at which this relay mining difficulty was computed.
    This is needed to determine how much time has passed since the last time
    the exponential moving average was computed.
    """
    num_relays_ema: builtins.int
    """The exponential moving average of the number of relays for this service."""
    target_hash: builtins.bytes
    """The target hash determining the difficulty to mine relays for this service.
    For example, if we use sha256 to hash the (RelayRequest,ReqlayResponse) tuple,
    and the difficulty has 4 leading zero bits, then the target hash would be:
    0b0000111... (until 32 bytes are filled up).
    """
    def __init__(
        self,
        *,
        service_id: builtins.str = ...,
        block_height: builtins.int = ...,
        num_relays_ema: builtins.int = ...,
        target_hash: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["block_height", b"block_height", "num_relays_ema", b"num_relays_ema", "service_id", b"service_id", "target_hash", b"target_hash"]) -> None: ...

global___RelayMiningDifficulty = RelayMiningDifficulty
