"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.message
import poktroll.session.types_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class Relay(google.protobuf.message.Message):
    """Relay contains both the RelayRequest (signed by the Application) and the RelayResponse (signed by the Supplier).
    The serialized tuple is inserted into the SMST leaves as values in the Claim/Proof lifecycle.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REQ_FIELD_NUMBER: builtins.int
    RES_FIELD_NUMBER: builtins.int
    @property
    def req(self) -> global___RelayRequest: ...
    @property
    def res(self) -> global___RelayResponse: ...
    def __init__(
        self,
        *,
        req: global___RelayRequest | None = ...,
        res: global___RelayResponse | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["req", b"req", "res", b"res"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["req", b"req", "res", b"res"]) -> None: ...

global___Relay = Relay

@typing.final
class RelayRequestMetadata(google.protobuf.message.Message):
    """RelayRequestMetadata contains the metadata for a RelayRequest."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SESSION_HEADER_FIELD_NUMBER: builtins.int
    SIGNATURE_FIELD_NUMBER: builtins.int
    SUPPLIER_OPERATOR_ADDRESS_FIELD_NUMBER: builtins.int
    signature: builtins.bytes
    """The request signature is a serialized ring signature that may have been
    by either the application itself or one of the gateways that the
    application has delegated to. The signature is made using the ring of the
    application in both cases.
    """
    supplier_operator_address: builtins.str
    """TODO_MAINNET: make sure we're checking/verifying this address on-chain (if needed).
    Relevant conversation: https://github.com/pokt-network/poktroll/pull/567#discussion_r1628722168

    The supplier operator address the relay is sent to. It is being used on the
    RelayMiner to route to the correct supplier.
    The Bech32 address of the application.
    """
    @property
    def session_header(self) -> poktroll.session.types_pb2.SessionHeader:
        """Session header associated with the relay."""

    def __init__(
        self,
        *,
        session_header: poktroll.session.types_pb2.SessionHeader | None = ...,
        signature: builtins.bytes = ...,
        supplier_operator_address: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["session_header", b"session_header"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["session_header", b"session_header", "signature", b"signature", "supplier_operator_address", b"supplier_operator_address"]) -> None: ...

global___RelayRequestMetadata = RelayRequestMetadata

@typing.final
class RelayRequest(google.protobuf.message.Message):
    """RelayRequest holds the request details for a relay."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    META_FIELD_NUMBER: builtins.int
    PAYLOAD_FIELD_NUMBER: builtins.int
    payload: builtins.bytes
    """payload is the serialized payload for the request.
    The payload is passed directly to the service and as such can be any
    format that the service supports: JSON-RPC, REST, gRPC, etc.
    """
    @property
    def meta(self) -> global___RelayRequestMetadata: ...
    def __init__(
        self,
        *,
        meta: global___RelayRequestMetadata | None = ...,
        payload: builtins.bytes = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["meta", b"meta"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["meta", b"meta", "payload", b"payload"]) -> None: ...

global___RelayRequest = RelayRequest

@typing.final
class RelayResponse(google.protobuf.message.Message):
    """RelayResponse contains the response details for a RelayRequest."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    META_FIELD_NUMBER: builtins.int
    PAYLOAD_FIELD_NUMBER: builtins.int
    payload: builtins.bytes
    """payload is the serialized payload for the response.
    The payload is passed directly from the service and as such can be any
    format the service responds with: JSON-RPC, REST, gRPC, etc.
    """
    @property
    def meta(self) -> global___RelayResponseMetadata: ...
    def __init__(
        self,
        *,
        meta: global___RelayResponseMetadata | None = ...,
        payload: builtins.bytes = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["meta", b"meta"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["meta", b"meta", "payload", b"payload"]) -> None: ...

global___RelayResponse = RelayResponse

@typing.final
class RelayResponseMetadata(google.protobuf.message.Message):
    """RelayResponseMetadata contains the metadata for a RelayResponse."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SESSION_HEADER_FIELD_NUMBER: builtins.int
    SUPPLIER_OPERATOR_SIGNATURE_FIELD_NUMBER: builtins.int
    supplier_operator_signature: builtins.bytes
    """Signature of the supplier's operator on the response."""
    @property
    def session_header(self) -> poktroll.session.types_pb2.SessionHeader:
        """Session header associated with the relay."""

    def __init__(
        self,
        *,
        session_header: poktroll.session.types_pb2.SessionHeader | None = ...,
        supplier_operator_signature: builtins.bytes = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["session_header", b"session_header"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["session_header", b"session_header", "supplier_operator_signature", b"supplier_operator_signature"]) -> None: ...

global___RelayResponseMetadata = RelayResponseMetadata
