"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class Params(google.protobuf.message.Message):
    """Params defines the parameters for the module."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NUM_BLOCKS_PER_SESSION_FIELD_NUMBER: builtins.int
    GRACE_PERIOD_END_OFFSET_BLOCKS_FIELD_NUMBER: builtins.int
    CLAIM_WINDOW_OPEN_OFFSET_BLOCKS_FIELD_NUMBER: builtins.int
    CLAIM_WINDOW_CLOSE_OFFSET_BLOCKS_FIELD_NUMBER: builtins.int
    PROOF_WINDOW_OPEN_OFFSET_BLOCKS_FIELD_NUMBER: builtins.int
    PROOF_WINDOW_CLOSE_OFFSET_BLOCKS_FIELD_NUMBER: builtins.int
    SUPPLIER_UNBONDING_PERIOD_SESSIONS_FIELD_NUMBER: builtins.int
    APPLICATION_UNBONDING_PERIOD_SESSIONS_FIELD_NUMBER: builtins.int
    COMPUTE_UNITS_TO_TOKENS_MULTIPLIER_FIELD_NUMBER: builtins.int
    num_blocks_per_session: builtins.int
    """num_blocks_per_session is the number of blocks between the session start & end heights."""
    grace_period_end_offset_blocks: builtins.int
    """grace_period_end_offset_blocks is the number of blocks, after the session end height,
    during which the supplier can still service payable relays.
    Suppliers will need to recreate a claim for the previous session (if already created) to
    get paid for the additional relays.
    """
    claim_window_open_offset_blocks: builtins.int
    """claim_window_open_offset_blocks is the number of blocks after the session grace
    period height, at which the claim window opens.
    """
    claim_window_close_offset_blocks: builtins.int
    """claim_window_close_offset_blocks is the number of blocks after the claim window
    open height, at which the claim window closes.
    """
    proof_window_open_offset_blocks: builtins.int
    """proof_window_open_offset_blocks is the number of blocks after the claim window
    close height, at which the proof window opens.
    """
    proof_window_close_offset_blocks: builtins.int
    """proof_window_close_offset_blocks is the number of blocks after the proof window
    open height, at which the proof window closes.
    """
    supplier_unbonding_period_sessions: builtins.int
    """supplier_unbonding_period_sessions is the number of sessions that a supplier must wait after
    unstaking before their staked assets are moved to their account balance.
    On-chain business logic requires, and ensures, that the corresponding block count of the unbonding
    period will exceed the end of any active claim & proof lifecycles.
    """
    application_unbonding_period_sessions: builtins.int
    """application_unbonding_period_sessions is the number of sessions that an application must wait after
    unstaking before their staked assets are moved to their account balance.
    On-chain business logic requires, and ensures, that the corresponding block count of the
    application unbonding period will exceed the end of its corresponding proof window close height.
    """
    compute_units_to_tokens_multiplier: builtins.int
    """The amount of upokt that a compute unit should translate to when settling a session.
    DEV_NOTE: This used to be under x/tokenomics but has been moved here to avoid cyclic dependencies.
    """
    def __init__(
        self,
        *,
        num_blocks_per_session: builtins.int = ...,
        grace_period_end_offset_blocks: builtins.int = ...,
        claim_window_open_offset_blocks: builtins.int = ...,
        claim_window_close_offset_blocks: builtins.int = ...,
        proof_window_open_offset_blocks: builtins.int = ...,
        proof_window_close_offset_blocks: builtins.int = ...,
        supplier_unbonding_period_sessions: builtins.int = ...,
        application_unbonding_period_sessions: builtins.int = ...,
        compute_units_to_tokens_multiplier: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["application_unbonding_period_sessions", b"application_unbonding_period_sessions", "claim_window_close_offset_blocks", b"claim_window_close_offset_blocks", "claim_window_open_offset_blocks", b"claim_window_open_offset_blocks", "compute_units_to_tokens_multiplier", b"compute_units_to_tokens_multiplier", "grace_period_end_offset_blocks", b"grace_period_end_offset_blocks", "num_blocks_per_session", b"num_blocks_per_session", "proof_window_close_offset_blocks", b"proof_window_close_offset_blocks", "proof_window_open_offset_blocks", b"proof_window_open_offset_blocks", "supplier_unbonding_period_sessions", b"supplier_unbonding_period_sessions"]) -> None: ...

global___Params = Params
