"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import cosmos.base.v1beta1.coin_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import poktroll.shared.service_pb2
import poktroll.supplier.params_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class MsgUpdateParams(google.protobuf.message.Message):
    """MsgUpdateParams is the Msg/UpdateParams request type."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUTHORITY_FIELD_NUMBER: builtins.int
    PARAMS_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority is the address that controls the module (defaults to x/gov unless overwritten)."""
    @property
    def params(self) -> poktroll.supplier.params_pb2.Params:
        """params defines the x/supplier parameters to update.
        NOTE: All parameters must be supplied.
        """

    def __init__(
        self,
        *,
        authority: builtins.str = ...,
        params: poktroll.supplier.params_pb2.Params | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["authority", b"authority", "params", b"params"]) -> None: ...

global___MsgUpdateParams = MsgUpdateParams

@typing.final
class MsgUpdateParamsResponse(google.protobuf.message.Message):
    """MsgUpdateParamsResponse defines the response structure for executing a
    MsgUpdateParams message.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgUpdateParamsResponse = MsgUpdateParamsResponse

@typing.final
class MsgStakeSupplier(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SIGNER_FIELD_NUMBER: builtins.int
    OWNER_ADDRESS_FIELD_NUMBER: builtins.int
    OPERATOR_ADDRESS_FIELD_NUMBER: builtins.int
    STAKE_FIELD_NUMBER: builtins.int
    SERVICES_FIELD_NUMBER: builtins.int
    signer: builtins.str
    """The Bech32 address of the message signer (i.e. owner or operator)"""
    owner_address: builtins.str
    """The Bech32 address of the owner (i.e. custodial, staker)"""
    operator_address: builtins.str
    """The Bech32 address of the operator (i.e. provider, non-custodial)"""
    @property
    def stake(self) -> cosmos.base.v1beta1.coin_pb2.Coin:
        """The total amount of uPOKT the supplier has staked. Must be ≥ to the current amount that the supplier has staked (if any)"""

    @property
    def services(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[poktroll.shared.service_pb2.SupplierServiceConfig]:
        """The list of services this supplier is staked to provide service for"""

    def __init__(
        self,
        *,
        signer: builtins.str = ...,
        owner_address: builtins.str = ...,
        operator_address: builtins.str = ...,
        stake: cosmos.base.v1beta1.coin_pb2.Coin | None = ...,
        services: collections.abc.Iterable[poktroll.shared.service_pb2.SupplierServiceConfig] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["stake", b"stake"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["operator_address", b"operator_address", "owner_address", b"owner_address", "services", b"services", "signer", b"signer", "stake", b"stake"]) -> None: ...

global___MsgStakeSupplier = MsgStakeSupplier

@typing.final
class MsgStakeSupplierResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgStakeSupplierResponse = MsgStakeSupplierResponse

@typing.final
class MsgUnstakeSupplier(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SIGNER_FIELD_NUMBER: builtins.int
    OPERATOR_ADDRESS_FIELD_NUMBER: builtins.int
    signer: builtins.str
    """The Bech32 address of the message signer (i.e. owner or operator)"""
    operator_address: builtins.str
    """The Bech32 address of the operator (i.e. provider, non-custodial)"""
    def __init__(
        self,
        *,
        signer: builtins.str = ...,
        operator_address: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["operator_address", b"operator_address", "signer", b"signer"]) -> None: ...

global___MsgUnstakeSupplier = MsgUnstakeSupplier

@typing.final
class MsgUnstakeSupplierResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgUnstakeSupplierResponse = MsgUnstakeSupplierResponse

@typing.final
class MsgUpdateParam(google.protobuf.message.Message):
    """MsgUpdateParam is the Msg/UpdateParam request type to update a single param."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUTHORITY_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    AS_COIN_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority is the address that controls the module (defaults to x/gov unless overwritten)."""
    name: builtins.str
    @property
    def as_coin(self) -> cosmos.base.v1beta1.coin_pb2.Coin: ...
    def __init__(
        self,
        *,
        authority: builtins.str = ...,
        name: builtins.str = ...,
        as_coin: cosmos.base.v1beta1.coin_pb2.Coin | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["asType", b"asType", "as_coin", b"as_coin"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["asType", b"asType", "as_coin", b"as_coin", "authority", b"authority", "name", b"name"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["asType", b"asType"]) -> typing.Literal["as_coin"] | None: ...

global___MsgUpdateParam = MsgUpdateParam

@typing.final
class MsgUpdateParamResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARAMS_FIELD_NUMBER: builtins.int
    @property
    def params(self) -> poktroll.supplier.params_pb2.Params: ...
    def __init__(
        self,
        *,
        params: poktroll.supplier.params_pb2.Params | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["params", b"params"]) -> None: ...

global___MsgUpdateParamResponse = MsgUpdateParamResponse
